#ifndef _IP_NAT_HELPER_H
#define _IP_NAT_HELPER_H
/* NAT protocol helper routines. */

#include "../conntrack/ip_conntrack.h"

struct sk_buff;

struct ip_nat_helper
{
	/* Internal use */
	struct list_head list;

	/* Here's the protocol and dst we care about. */
	u_int16_t protocol;
	u_int16_t protocol_dst;

	/* Helper function */
	unsigned int (*help)(struct ip_conntrack_tuple_hash *h,
			     struct ip_nat_info *info,
			     enum ip_conntrack_info conntrackinfo,
			     struct sk_buff **pskb);
};

extern int ip_nat_helper_register(struct ip_nat_helper *me);
extern void ip_nat_helper_unregister(struct ip_nat_helper *me);
#endif 
