#! /bin/sh
# Test to see if rewriting works.

# Job control required
set -m

insmod ../test/redirect.o hook=2 || exit 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 58 59 | ./intercept FORWARD ACCEPT 6 1 2 mangle > /dev/null &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0
sleep 1

if ./rcv_ip 4 1 < /dev/tap1 > $TMPFILE
then :
else
    echo ./rcv_ip failed after pass through
    cat $TMPFILE
    exit 1
fi

if wait %./intercept; then :
else
    echo Intercept failed.
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP0NET.2 $TAP1NET.2 100 1 8 0 58 59 " ]
then
    echo Unexpected receive: \`"`cat $TMPFILE`"\'
    exit 1
fi

rmmod redirect || exit 1

exit 0

