#! /bin/sh

# Need job control.
set -m

# Policy setting.
# Can't set policy on user-defined
../packet-filter/userspace/iptables -N foo || exit 1
../packet-filter/userspace/iptables -P foo ACCEPT 2>/dev/null && exit 1

../packet-filter/userspace/iptables -F FORWARD || exit 1
../packet-filter/userspace/iptables -P FORWARD ACCEPT || exit 1
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

if wait %./rcv_ip
then :
else
    echo Policy setting failed.
    cat $TMPFILE
    exit 1
fi

if [ "`../packet-filter/userspace/iptables -L FORWARD -v`" != "Chain FORWARD (policy ACCEPT 1 packets, 100 bytes)
 pkts bytes target     prot opt tos  in        out       source                destination          " ]
then
    echo Unexpected iptables -L FORWARD after -P.
    exit 1
fi

exit 0
