#! /bin/sh

# Need job control.
set -m

# Test the various different src/dst match possibilities

for i in "" "-d 0/0" "-d $TAP1NET.0/24" "-d $TAP1NET.2" "-d ! $TAP0NET.2" "! -d $TAP0NET.2" "-d $TAP1NET.3/24" "-d $TAP0NET.2/255.255.0.255"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j ACCEPT || exit 1
    ./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %./rcv_ip; then :
    else
	echo ./rcv_ip failed for \`$i\':
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

../packet-filter/userspace/iptables -P FORWARD ACCEPT || exit 1
for i in "-d ! $TAP1NET.2" "! -d 0/0" "-d $TAP0NET.0/24" "-d $TAP0NET.2"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j DROP || exit 1
    ./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %./rcv_ip; then :
    else
	echo ./rcv_ip failed for \`$i\':
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

exit 0
