#! /bin/sh

# Need job control.
set -m

# Test the various options for the limit match.
insmod ../packet-filter/extentions/ipt_mac.o || exit 1

# Must force mac address.
../packet-filter/userspace/iptables -A FORWARD -m mac 2>/dev/null && exit 1

# Mac address
../packet-filter/userspace/iptables -A FORWARD -m mac --mac-source 01:02:03:04:05:06 -j ACCEPT || exit 1

# Send packet through
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip MAC=01:02:03:04:05:06 $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0 || exit 1

if wait %./rcv_ip; then :
else
    echo rcv_ip failed:
    cat $TMPFILE
fi

# Send non-match packet through
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip MAC=01:02:03:04:05:07 $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0 || exit 1

if wait %./rcv_ip
then
    echo rcv_ip succeeded:
    cat $TMPFILE
fi

# Replace rule with inverse.
../packet-filter/userspace/iptables -A FORWARD -m mac --mac-source ! 01:02:03:04:05:06 -j ACCEPT || exit 1

# Send packet through
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip MAC=01:02:03:04:05:07 $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0 || exit 1

if wait %./rcv_ip; then :
else
    echo rcv_ip failed on inverse-mac:
    cat $TMPFILE
fi

# Send non-match packet through
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip MAC=01:02:03:04:05:06 $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0 || exit 1

if wait %./rcv_ip
then
    echo rcv_ip succeeded on inverse-mac:
    cat $TMPFILE
fi

../packet-filter/userspace/iptables -F FORWARD || exit 1
rmmod ipt_mac || exit 1
exit 0
