#! /bin/sh

# Test that reply packets are recognized as part of same connection.

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 1025 SYN > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 1024 1025 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 2 > /dev/tap0

./gen_ip $TAP1NET.2 $TAP0NET.2 100 1 0 0 55 57 > /dev/tap1
./gen_ip $TAP1NET.2 $TAP0NET.2 100 17 1025 1024 > /dev/tap1
./gen_ip $TAP1NET.2 $TAP0NET.2 100 2 > /dev/tap1
./gen_ip $TAP1NET.2 $TAP0NET.2 100 6 1025 1024 SYN/ACK > /dev/tap1
./gen_ip $TAP1NET.2 $TAP0NET.2 100 6 1025 1024 RST > /dev/tap1

cat /proc/net/ip_conntrack > $TMPFILE

# ICMP gets deleted by reply.
if [ `wc -l < $TMPFILE` != 3 ]
then
    echo Reply packets caused new connections:
    cat $TMPFILE
    exit 1
fi

if grep "^udp      17 [0-9]* src=$TAP0NET.2 dst=$TAP1NET.2 sport=1024 dport=1025 \src=$TAP1NET.2 dst=$TAP0NET.2 sport=1025 dport=1024 $" $TMPFILE > /dev/null && grep "^tcp      6 [0-9]* CLOSE src=$TAP0NET.2 dst=$TAP1NET.2 sport=1024 dport=1025 src=$TAP1NET.2 dst=$TAP0NET.2 sport=1025 dport=1024 $" $TMPFILE > /dev/null && grep "^unknown  2 [0-9]* src=$TAP0NET.2 dst=$TAP1NET.2 src=$TAP1NET.2 dst=$TAP0NET.2 $" $TMPFILE > /dev/null
then
    :
else
    echo Replies not tracked properly:
    cat $TMPFILE
    exit 1
fi

# Non-replies: new connections (except ICMP pong won't).
./gen_ip $TAP1NET.2 $TAP0NET.2 100 1 0 0 56 58 > /dev/tap0
./gen_ip $TAP1NET.2 $TAP0NET.2 100 6 1024 1024 SYN/ACK > /dev/tap0
./gen_ip $TAP1NET.2 $TAP0NET.2 100 6 1025 1023 SYN/ACK > /dev/tap0
./gen_ip $TAP1NET.2 $TAP0NET.2 100 17 1024 1024 > /dev/tap0
./gen_ip $TAP1NET.2 $TAP0NET.2 100 17 1025 1025 > /dev/tap0
./gen_ip $TAP1NET.2 $TAP0NET.2 100 3 > /dev/tap0

if [ `wc -l < /proc/net/ip_conntrack` != 8 ]
then
    echo Non-reply packets didn\'t cause new connections:
    cat /proc/net/ip_conntrack
    exit 1
fi

exit 0
