#! /bin/sh

# Loopback and locally-generated packets have various of their own
# problems.  We use netcat here to generate locally-produced packets.

# Need job control.
set -m

# First no conntracks
if [ "`cat /proc/net/ip_conntrack`" != "" ]
then
    echo Non-empty /proc/net/ip_conntrack:
    cat /proc/net/ip_conntrack
    exit 1
fi

# No mapping: loopback udp gives one conntrack.
echo test | nc -w 1 -u -p 100 127.0.0.1 102

if [ `wc -l < /proc/net/ip_conntrack` != 1 ]
then
    echo Unexpected /proc/net/ip_conntrack after local UDP:
    cat /proc/net/ip_conntrack
    exit 1
fi

exit 0