#! /bin/sh

# Script to test ftp module's tracking code.

# Need job control.
set -m

insmod ../conntrack/extentions/ip_conntrack_ftp.o || exit 1

# Handshake, then send FTP PORT command, then PASV response.
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 SYN > /dev/tap0 || exit 1
./gen_ip $TAP1NET.2 $TAP0NET.2 100 6 21 1024 SYN/ACK > /dev/tap1 || exit 1
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK > /dev/tap0 || exit 1

# Check conntrack.
if [ "`cat /proc/net/ip_conntrack | grep ^EXPECTING:`" != "" ]
then
    echo Have unexpected expecting:
    cat /proc/net/ip_conntrack
    exit 1
fi

# FTP PORT COMMAND
echo -e "PORT `echo $TAP0NET.2 | tr . ,`,7,236\\r" |
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK DATA > /dev/tap0 || exit 1

if [ "`cat /proc/net/ip_conntrack | grep ^EXPECTING:`" != "EXPECTING: proto=6 src=$TAP1NET.2 dst=$TAP0NET.2 sport=0 dport=2028 " ]
then
    echo Have strange PORT expecting:
    cat /proc/net/ip_conntrack
    exit 1
fi

# FTP PASV response COMMAND
echo -e "227 Entering Passive Mode (`echo $TAP1NET.2 | tr . ,`,0,20)\\r" |
./gen_ip $TAP1NET.2 $TAP0NET.2 100 6 21 1024 ACK DATA > /dev/tap1 || exit 1

if [ "`cat /proc/net/ip_conntrack | grep ^EXPECTING:`" != "EXPECTING: proto=6 src=$TAP0NET.2 dst=$TAP1NET.2 sport=0 dport=20 " ]
then
    echo Have strange PASV expecting:
    cat /proc/net/ip_conntrack
    exit 1
fi

# Generate reset to facilitate removal.
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 RST > /dev/tap0
sleep 10

rmmod ip_conntrack_ftp || exit 1

exit 0
