#! /bin/sh

# Test for simple IP RNAT replies.

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.0/24 -d $TAP1NET.2 -b dest -t $TAP1NET.3 || exit 1

# ICMP, UDP, TCP and unknown
./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 53 53 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 8080 SYN > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 2 > /dev/tap0

../NAT/userspace/ipnatctl -D -s $TAP0NET.0/24 -d $TAP1NET.2 -b dest -t $TAP1NET.3 || exit 1

# Send four replies: should be mirrored back.
./rcv_ip 2 4 < /dev/tap0 > $TMPFILE &
sleep 1

./gen_ip $TAP1NET.3 $TAP0NET.2 100 1 0 0 55 57 > /dev/tap1
./gen_ip $TAP1NET.3 $TAP0NET.2 100 17 53 53 > /dev/tap1
./gen_ip $TAP1NET.3 $TAP0NET.2 100 6 8080 1024 SYN/ACK > /dev/tap1
./gen_ip $TAP1NET.3 $TAP0NET.2 100 2 > /dev/tap1

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

for answer in "$TAP1NET.2 $TAP0NET.2 100 1 0 0 55 57" \
	      "$TAP1NET.2 $TAP0NET.2 100 17 53 53" \
	      "$TAP1NET.2 $TAP0NET.2 100 6 8080 1024 SYN/ACK" \
	      "$TAP1NET.2 $TAP0NET.2 100 2"
do
    read LINE
    if [ "$LINE" != "$answer" ]
    then
	echo Unexpected answer \`"$LINE"\' vs \`"$answer"\'
	exit 1
    fi
done < $TMPFILE

exit 0

