#! /bin/sh

# Tests generations: deleting a state should cause second lookup on skb.

# Need job control.
set -m

# Tell intercept to hold packet at forward hook for 1 second.
insmod ../test/redirect.o hook=2 || exit 1
insmod ../device/netfilter_dev.o || exit 1

./intercept FORWARD ACCEPT 4 1 1 > /dev/null &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

# Create and destroy a state.
ping -c 1 127.0.0.1

if ./rcv_ip 5 1 < /dev/tap1 > $TMPFILE 
then :
else
    echo rcv_ip failed.
    cat $TMPFILE
    exit 1
fi

if wait %./intercept; then :
else
    echo intercept failed.
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 " ]
then
    echo Unexpected receive: \`"`cat $TMPFILE`"\'.
    exit 1
fi

rmmod redirect || exit 1
rmmod netfilter_dev || exit 1

exit 0